/***********************************************************************
*                                                                      *
*    This function compares the possible new key with a key stored     *
*    in the B-Tree.  The function returns the value '0' if the keys    *
*    match, '1' if the new key is lexicographically less than the      *
*    stored key, and '2' if the new key is lexicographically more      *
*    than the stored key.                                              *
*                                                                      *
***********************************************************************/



#include "def.h"

CompareKeys(Key, Word)
char *Key,    /* Possible New Key */
*Word;   /* The Key Stored in the B-Tree */
{
    /* Auxiliary Definition */
    double  Difference;
    double strdist(char *str1, char*str2);

    Difference = strdist (Key,Word);

    if (Difference == 0)    /* There is a match */
        return(0);
    if (Difference < 0)     /* New Key < Stored Key */
        return(1);
    if (Difference > 0)     /* New Key > Stored Key */
        return(2);
}


